static void string_dealloc ( PyObject *op );
static int string_print ( PyStringObject *op , FILE *fp , int flags );
static PyObject *string_repr ( PyStringObject *op );
static int string_length ( PyStringObject *a );
static PyObject *string_concat ( PyStringObject *a , PyObject *bb );
static PyObject *string_repeat ( PyStringObject *a , int n );
static PyObject *string_slice ( PyStringObject *a , int i , int j );
static PyObject *string_item ( PyStringObject *a , int i );
static int string_compare ( PyStringObject *a , PyStringObject *b );
static long string_hash ( PyStringObject *a );
static int string_buffer_getreadbuf ( PyStringObject *self , int index , const void **ptr );
static int string_buffer_getwritebuf ( PyStringObject *self , int index , const void **ptr );
static int string_buffer_getsegcount ( PyStringObject *self , int *lenp );
static int string_buffer_getcharbuf ( PyStringObject *self , int index , const char **ptr );
static PyObject *getnextarg ( PyObject *args , int arglen , int *p_argidx );
static int formatfloat ( char *buf , int flags , int prec , int type , PyObject *v );
static int formatint ( char *buf , int flags , int prec , int type , PyObject *v );
static int formatchar ( char *buf , PyObject *v );

static int string_contains ( PyObject *a , PyObject *el );

static PyObject *split_whitespace ( char *s , int len , int maxsplit );
static PyObject *string_split ( PyStringObject *self , PyObject *args );
static PyObject *string_join ( PyStringObject *self , PyObject *args );
static long string_find_internal ( PyStringObject *self , PyObject *args , int dir );
static PyObject *string_find ( PyStringObject *self , PyObject *args );
static PyObject *string_index ( PyStringObject *self , PyObject *args );
static PyObject *string_rfind ( PyStringObject *self , PyObject *args );
static PyObject *string_rindex ( PyStringObject *self , PyObject *args );
static PyObject *do_strip ( PyStringObject *self , PyObject *args , int striptype );
static PyObject *string_strip ( PyStringObject *self , PyObject *args );
static PyObject *string_lstrip ( PyStringObject *self , PyObject *args );
static PyObject *string_rstrip ( PyStringObject *self , PyObject *args );
static PyObject *string_lower ( PyStringObject *self , PyObject *args );
static PyObject *string_upper ( PyStringObject *self , PyObject *args );
static PyObject *string_title ( PyUnicodeObject *self , PyObject *args );
static PyObject *string_capitalize ( PyStringObject *self , PyObject *args );
static PyObject *string_count ( PyStringObject *self , PyObject *args );
static PyObject *string_swapcase ( PyStringObject *self , PyObject *args );
static PyObject *string_translate ( PyStringObject *self , PyObject *args );
static PyObject *string_replace ( PyStringObject *self , PyObject *args );
static PyObject *string_startswith ( PyStringObject *self , PyObject *args );
static PyObject *string_endswith ( PyStringObject *self , PyObject *args );
static PyObject *string_expandtabs ( PyStringObject *self , PyObject *args );
static PyObject *string_ljust ( PyStringObject *self , PyObject *args );
static PyObject *string_rjust ( PyStringObject *self , PyObject *args );
static PyObject *string_center ( PyStringObject *self , PyObject *args );
// static PyObject *string_zfill ( PyStringObject *self , PyObject *args );
static PyObject *string_isspace ( PyStringObject *self , PyObject *args );
static PyObject *string_isdigit ( PyStringObject *self , PyObject *args );
static PyObject *string_islower ( PyStringObject *self , PyObject *args );
static PyObject *string_isupper ( PyStringObject *self , PyObject *args );
static PyObject *string_istitle ( PyStringObject *self , PyObject *args );
static PyObject *string_splitlines ( PyStringObject *self , PyObject *args );
static PyObject *string_getattr ( PyStringObject *s , char *name );

static int mymemfind ( char *mem , int len , char *pat , int pat_len );
static int mymemcnt ( char *mem , int len , char *pat , int pat_len );
static char *mymemreplace ( char *str , int len , char *pat , int pat_len , char *sub , int sub_len , int count , int *out_len );
