static PyObject *code_getattr ( PyCodeObject *co , char *name );
static void code_dealloc ( PyCodeObject *co );
static PyObject *code_repr ( PyCodeObject *co );
static int code_compare ( PyCodeObject *co , PyCodeObject *cp );
static long code_hash ( PyCodeObject *co );
static void com_error ( struct compiling *c , PyObject *exc , char *msg );
static void block_push ( struct compiling *c , int type );
static void block_pop ( struct compiling *c , int type );
static void com_add_lnotab ( struct compiling *c , int addr , int line );
static void com_set_lineno ( struct compiling *c , int lineno );
static void com_addoparg ( struct compiling *c , int op , int arg );
static void com_addfwref ( struct compiling *c , int op , int *p_anchor );
static void com_backpatch ( struct compiling *c , int anchor );
static int com_mangle ( struct compiling *c , char *name , char *buffer , int maxlen );
static void com_addopnamestr ( struct compiling *c , int op , char *name );
static PyObject *parsenumber ( struct compiling *co , char *s );
static PyObject *parsestr ( char *s );
static PyObject *parsestrplus ( node *n );
static void com_list_constructor ( struct compiling *c , node *n );
static void com_dictmaker ( struct compiling *c , node *n );
static void com_atom ( struct compiling *c , node *n );
static void com_slice ( struct compiling *c , node *n , int op );
static void com_argument ( struct compiling *c , node *n , PyObject **pkeywords );
static void com_call_function ( struct compiling *c , node *n );
static void com_select_member ( struct compiling *c , node *n );
static void com_sliceobj ( struct compiling *c , node *n );
static void com_subscript ( struct compiling *c , node *n );
static void com_subscriptlist ( struct compiling *c , node *n , int assigning );
static void com_apply_trailer ( struct compiling *c , node *n );
static void com_power ( struct compiling *c , node *n );
static void com_factor ( struct compiling *c , node *n );
static void com_term ( struct compiling *c , node *n );
static void com_arith_expr ( struct compiling *c , node *n );
static void com_shift_expr ( struct compiling *c , node *n );
static void com_and_expr ( struct compiling *c , node *n );
static void com_xor_expr ( struct compiling *c , node *n );
static void com_expr ( struct compiling *c , node *n );
static enum cmp_op cmp_type ( node *n );
static void com_comparison ( struct compiling *c , node *n );
static void com_not_test ( struct compiling *c , node *n );
static void com_and_test ( struct compiling *c , node *n );
static void com_test ( struct compiling *c , node *n );
static void com_list ( struct compiling *c , node *n , int toplevel );
static void com_assign_attr ( struct compiling *c , node *n , int assigning );
static void com_assign_trailer ( struct compiling *c , node *n , int assigning );
static void com_assign_tuple ( struct compiling *c , node *n , int assigning );
static void com_assign_list ( struct compiling *c , node *n , int assigning );
static void com_assign_name ( struct compiling *c , node *n , int assigning );
static void com_assign ( struct compiling *c , node *n , int assigning );
static void com_expr_stmt ( struct compiling *c , node *n );
static void com_assert_stmt ( struct compiling *c , node *n );
static void com_print_stmt ( struct compiling *c , node *n );
static void com_return_stmt ( struct compiling *c , node *n );
static void com_raise_stmt ( struct compiling *c , node *n );
static void com_import_stmt ( struct compiling *c , node *n );
static void com_global_stmt ( struct compiling *c , node *n );
static int com_newlocal_o ( struct compiling *c , PyObject *nameval );
static int com_addlocal_o ( struct compiling *c , PyObject *nameval );
static int com_newlocal ( struct compiling *c , char *name );
static void com_exec_stmt ( struct compiling *c , node *n );
static int is_constant_false ( struct compiling *c , node *n );
static void com_if_stmt ( struct compiling *c , node *n );
static void com_while_stmt ( struct compiling *c , node *n );
static void com_for_stmt ( struct compiling *c , node *n );
static void com_try_except ( struct compiling *c , node *n );
static void com_try_finally ( struct compiling *c , node *n );
static void com_try_stmt ( struct compiling *c , node *n );
static node *get_rawdocstring ( node *n );
static PyObject *get_docstring ( node *n );
static void com_suite ( struct compiling *c , node *n );
static void com_continue_stmt ( struct compiling *c , node *n );
static int com_argdefs ( struct compiling *c , node *n );
static void com_funcdef ( struct compiling *c , node *n );
static void com_bases ( struct compiling *c , node *n );
static void com_classdef ( struct compiling *c , node *n );
static void com_node ( struct compiling *c , node *n );
static void com_fpdef ( struct compiling *c , node *n );
static void com_fplist ( struct compiling *c , node *n );
static void com_arglist ( struct compiling *c , node *n );
static void com_file_input ( struct compiling *c , node *n );
static void compile_funcdef ( struct compiling *c , node *n );
static void compile_lambdef ( struct compiling *c , node *n );
static void compile_classdef ( struct compiling *c , node *n );
static void compile_node ( struct compiling *c , node *n );
static void optimize ( struct compiling *c );
static PyCodeObject *icompile ( node *n , struct compiling *base );
static PyCodeObject *jcompile ( node *n , char *filename , struct compiling *base );
